Txtab <- function(df) {
 stopifnot(is.data.frame(df)) # only data frames allowed
 .sepline <- function(n) {
  tmp <- lapply(n, function(.x) paste(rep("-", .x + 2), collapse=""))
  paste0("+", paste(tmp, collapse="+"), "+")
  }
 .row <- function(x, n) {
  .format <- function(i, x, n) {
   string <- paste0("%", n[i], "s")
   sprintf(string, as.character(x[i]))
   }
  tmp <- sapply(seq_along(x), .format, x=x, n=n)
  paste0("|", paste(paste0(" ", tmp, " "), collapse="|"), "|")
 }
 df <- as.matrix(df) ## to character mode, if characters present
 mdf <- apply(df, 2, function(x) max(nchar(x))) # width of data
 cnames <- nchar(colnames(df)) # width of column names
 M <- pmax(mdf, cnames) # max of data and colnames widths
 ## header:
 sep <- .sepline(M)
 writeLines(sep)
 writeLines(.row(colnames(df), M))
 writeLines(sep)
 ## rows:
 for(i in seq_len(nrow(df))) {
    writeLines(.row(df[i, ], M))
    writeLines(sep)
 }
 invisible(df)
}
